import logo from './logo.svg';
import ClockFace from './img/ClockFace.png';
import ClockFaceH from './img/ClockFace_H.png';
import ClockFaceM from './img/ClockFace_M.png';
import ClockFaceS from './img/ClockFace_S.png';
import './App.scss';
import {useEffect, useRef, useState} from 'react'
import React, { Component } from 'react';
///////////////////////////////////////Spoiler
const Content = () => 
<p>
	hello world
</p>

const Spoiler = ({header="+", open=true,children}) => {
	const [bool, setBool] = useState(open);

	return(
		<>
			<div onClick={() => setBool(!bool)}>{header}</div>                     
			{bool && children}
		</>
	)
}
///////////////////////////////////////////////////////////////////////RangeInput
const RangeInput = ({min, max}) => {
	const [value, setValue] = useState('');

	const input = useRef()

	useEffect(()=> {
		
		if (value.length > min && value.length < max || value.length === 0){
			input.current.style.backgroundColor = ''
		} else {
			input.current.style.backgroundColor = 'red'
		}
	}, [value])
	
	
	return(
		<>
			<input value={value} ref={input} onChange={(e) => setValue(e.target.value)}/>
		</>
	) 
}



///////////////////////////////////////PasswordConfirm
const PasswordConfirm = ({min}) => {
	const [firstValue, setFirstValue] = useState('');
	const [secondValue, setSecondValue] = useState('');
	const [bool, setBool] = useState(false);

	const firstInput = useRef();
	const secondInput = useRef();
	const button = useRef();

	useEffect(() => {
		(firstValue.length > min || firstValue.length === 0) ? firstInput.current.style.backgroundColor = '' : firstInput.current.style.backgroundColor = 'red';
		(secondValue.length > min || secondValue.length === 0) ? secondInput.current.style.backgroundColor = '' : secondInput.current.style.backgroundColor = 'red';
		(firstValue.length > min && secondValue.length > min) ? button.current.disabled = false : button.current.disabled = true;

	}, [firstValue, secondValue])
	
	


	return(
		<>
			<input value={firstValue} ref={firstInput} type='password' onChange={(e) => setFirstValue(e.target.value)}/>
			<input value={secondValue} ref={secondInput} type='password' onChange={(e) => setSecondValue(e.target.value)}/>
			<button ref={button} onClick={() => {firstValue === secondValue ? setBool(false) : setBool(true)}}>OK</button>
			{bool && <div>something went wrong</div>}
		</>
	)
}
///////////////////////////////////////////////////Timer
const Timer = ({seconds}) => {
	const [timer, setTimer] = useState(seconds);
	const [start, setStart] = useState((performance.now()/1000).toFixed(1));
	const [bool, setBool] = useState(true);

	useEffect(() => {
		let interval
		if (bool) {
			if (timer > 0){
				interval = setInterval(() =>{
					setTimer(timer - Math.floor(((performance.now()/1000).toFixed(1)-start)))//проверка увеличился ли на 1 сек performance именно Math.floor -
				}, 100)																			//  -- чтобы раньше не переключить
			}                                                                  
		}
		
		return () => {
			clearInterval(interval)
			
		}
	}, [bool, start])

	useEffect(() => {
		if(timer === 0){
			setBool(!bool)
		}
	}, [timer])
	
	return(
		<>
			<div>
				<span>{Math.trunc(timer/3600)%24 < 10 ? '0'+Math.trunc(timer/3600)%24 : Math.trunc(timer/3600)%24}</span>
				<span>:{Math.trunc(timer/60)%60 < 10 ? '0'+Math.trunc(timer/60)%60 : Math.trunc(timer/60)%60}</span>
				<span>:{timer%60 < 10 ? '0'+timer%60 : timer%60}</span>
			</div>
			<button onClick={() => {setStart((performance.now()/1000).toFixed(1)); setBool(!bool)}}>{bool ? 'stop' : 'start'}</button>
		</>
	)
}
////////////////////////////////////////TimerControl

const TimerControl = ({render: Render}) => {
	const [valueH, setValueH] = useState('');
	const [valueM, setValueM] = useState('');
	const [valueS, setValueS] = useState('');
 	const [bool,setBool] = useState(false);
	const button = useRef();

	useEffect(() => {
		(!isNaN(valueH) && !isNaN(valueM) && !isNaN(valueS) && valueH.length>0 && valueM.length>0 && valueS.length>0 ) ? button.current.disabled = false : button.current.disabled = true
	}, [valueH, valueM, valueS]);

	return (
		<>
			<br/>
			<input value={valueH} placeholder='часы' onChange={(e) => setValueH(e.target.value)}/><br/>
			<input value={valueM} placeholder='минуты' onChange={(e) => setValueM(e.target.value)}/><br/>
			<input value={valueS} placeholder='секунды' onChange={(e) => setValueS(e.target.value)}/><br/>
			<button ref={button} onClick={() => setBool(!bool)}>{bool ? 'finish'  : 'start'  }</button>
			
			{bool && <Render seconds={(+valueH*3600) + (+valueM*60) + +valueS}/>}
		</>
	)
}
/////////////////////////////////////////////////////////////////TimerContainer
const SecondsTimer = ({seconds}) => <h2>{seconds}</h2>

const TimerContainer = ({seconds, refresh, render: Render}) => {
	const [timer, setTimer] = useState(seconds);
	const [start, setStart] = useState((performance.now()/1000).toFixed(1));
	const [bool, setBool] = useState(true);

	useEffect(() => {
		let interval
		if (bool) {
			if (timer > 0){
				interval = setInterval(() =>{
					setTimer(timer - Math.floor(((performance.now()/1000).toFixed(1)-start)))
				}, refresh)																			
			}                                                                  
		}
		
		return () => {
			clearInterval(interval)
			
		}
	}, [bool, start])

	useEffect(() => {
		if(timer === 0){
			setBool(!bool)
		}
	}, [timer])

	return (
		<Render seconds={timer} setStart={setStart} setBool={setBool} bool={bool}/>
	)
}
//////////////////////////////////////LCD
const TimerPresentation = ({seconds, bool, setBool, setStart}) => {
	return(
		<>
			<div>
				<span>{Math.trunc(seconds/3600)%24 < 10 ? '0'+Math.trunc(seconds/3600)%24 : Math.trunc(seconds/3600)%24}</span>
				<span>:{Math.trunc(seconds/60)%60 < 10 ? '0'+Math.trunc(seconds/60)%60 : Math.trunc(seconds/60)%60}</span>
				<span>:{seconds%60 < 10 ? '0'+seconds%60 : seconds%60}</span>
			</div>
			<button onClick={() => {setStart((performance.now()/1000).toFixed(1)); setBool(!bool)}}>{bool ? 'stop' : 'start'}</button>
		</>
	)
}
/////////////////////////////////////Watch
const Watch = ({seconds, bool, setBool, setStart}) => {
	return(
		<>
			<div style={{position: 'relative', width: '400px', height: '400px'}}>
				<img style={{position: 'absolute'}} src={ClockFace}/>
				<img style={{position: 'absolute', transform: `rotate(${(Math.trunc(seconds/3600)%24) * 30}deg)`}} src={ClockFaceH}/>
				<img style={{position: 'absolute', transform: `rotate(${(Math.trunc(seconds/60)%60) * 6}deg)`}} src={ClockFaceM}/>
				<img style={{position: 'absolute', transform: `rotate(${seconds%60 * 6}deg)`}} src={ClockFaceS}/>
			</div>
			
			<button style={{display: 'block'}} onClick={() => {setStart((performance.now()/1000).toFixed(1)); setBool(!bool)}}>{bool ? 'stop' : 'start'}</button>
		</>
	)
} 
/////////////////////////////////////////////TimerControl + TimerContainer

const TimerControl2 = ({render: Render}) => {
	const [valueH, setValueH] = useState('');
	const [valueM, setValueM] = useState('');
	const [valueS, setValueS] = useState('');

	const [optionValue, setOptionValue] = useState('TimerPresentation');
 	const [bool,setBool] = useState(false);
	const button = useRef();
	const [timers,setTimers] = useState({'TimerPresentation': TimerPresentation, 'SecondsTimer': SecondsTimer, 'Watch': Watch})

	

	
	useEffect(() => {
		(!isNaN(valueH) && !isNaN(valueM) && !isNaN(valueS) && valueH.length>0 && valueM.length>0 && valueS.length>0 ) ? button.current.disabled = false : button.current.disabled = true
	}, [valueH, valueM, valueS]);


	
	return (
		<>
			<br/>
			<input value={valueH} placeholder='часы' onChange={(e) => setValueH(e.target.value)}/><br/>
			<input value={valueM} placeholder='минуты' onChange={(e) => setValueM(e.target.value)}/><br/>
			<input value={valueS} placeholder='секунды' onChange={(e) => setValueS(e.target.value)}/><br/>
			<button ref={button} onClick={() => setBool(!bool)}>{bool ? 'finish'  : 'start'}</button>

			<select value={optionValue} onChange={(e) => setOptionValue(e.target.value)}> 
				<option>TimerPresentation</option>
				<option>SecondsTimer</option>
				<option>Watch</option>
			</select>
			
			{bool && <Render seconds={(+valueH*3600) + (+valueM*60) + +valueS} refresh={100} render={timers[optionValue]}/>}
		</>
	)
}
///////////////



////////////////////////////////////////////////////////////
function App() {
  return (
    <div className="App">
		{/* <Spoiler header={<h1>Header</h1>}>
			<Content/>
		</Spoiler>
		<Spoiler header='wqwqw'>
			some text
		</Spoiler> */}

		{/* <RangeInput min={3} max={10}/> */}

		{/* <PasswordConfirm min={3}/>  */}
		{/* <Timer/> */}
		{/* <TimerControl render={Timer}/> */}
		{/* <TimerContainer seconds={100} refresh={100} render={SecondsTimer}/>
		<TimerContainer seconds={100} refresh={100} render={TimerPresentation}/>
		<TimerContainer seconds={100} refresh={100} render={Watch}/> */}
		<TimerControl2 render={TimerContainer}/>
		
		
    </div>
  );
}

export default App;
